﻿using System;
using System.Linq;
using System.Text;
using System.ComponentModel;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.DC;
using System.Collections.Generic;
using DevExpress.ExpressApp.Model;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Updating;
using DevExpress.ExpressApp.Model.Core;
using DevExpress.ExpressApp.Model.DomainLogics;
using DevExpress.ExpressApp.Model.NodeGenerators;
using DevExpress.ExpressApp.Win.Templates;
using Panoptes.Module.Model;
using Xafari.Model;
using Xafari.Arms.Model;
using Xafari.Arms.Win.Templates;

namespace Panoptes.Module.Win {
    [ToolboxItemFilter("Xaf.Platform.Win")]
    // For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppModuleBasetopic.aspx.
    public sealed partial class PanoptesWindowsFormsModule : ModuleBase {
        public PanoptesWindowsFormsModule() {
            InitializeComponent();
        }
        public override IEnumerable<ModuleUpdater> GetModuleUpdaters(IObjectSpace objectSpace, Version versionFromDB) {
            return ModuleUpdater.EmptyModuleUpdaters;
        }
        public override void Setup(XafApplication application) {
            base.Setup(application);
            // Manage various aspects of the application UI and behavior at the module level.
            this.Application.CreateCustomTemplate += Application_CreateCustomTemplate; //Arms

        }
        void Application_CreateCustomTemplate(object sender, CreateCustomTemplateEventArgs e)
        {
            //Arms
            if (this.Application == null || this.Application.Model == null)
                return;
            if (e.Context == TemplateContext.ApplicationWindow)
            {
                e.Template = ((IModelPanoptes)this.Application.Model.Xafari().Arms().ArmDesign).EnableARMs ? new ArmsMainForm() : null;
            }
            else if (e.Context == TemplateContext.View)
                e.Template = new DetailViewForm();
        }

    }

    
}
