﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DevExpress.Data.Filtering;
using DevExpress.ExpressApp;
using DevExpress.ExpressApp.Actions;
using DevExpress.ExpressApp.Editors;
using DevExpress.ExpressApp.Layout;
using DevExpress.ExpressApp.Model.NodeGenerators;
using DevExpress.ExpressApp.SystemModule;
using DevExpress.ExpressApp.Templates;
using DevExpress.ExpressApp.Utils;
using DevExpress.Persistent.Base;
using DevExpress.Persistent.Validation;
using Panoptes.Module.Model;
using Xafari.Arms.Model;
using Xafari.Model;
using Xafari.Arms;
using DevExpress.ExpressApp.Model;

namespace Panoptes.Module.Controllers
{
    // For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppViewControllertopic.aspx.
    public partial class EnableARMsViewController : ViewController, IModelExtender
    {
        public EnableARMsViewController()
        {
            InitializeComponent();
            RegisterActions(components);
        }

        protected override void OnFrameAssigned()
        {
            var enableArms = (((IModelPanoptes)((IModelXafariArms)((IModelApplicationXafari)Application.Model).Xafari).ArmDesign).EnableARMs);
            if (!enableArms)
            {
                var armController = this.Frame.GetController<ArmController>();
                var showNavigationItemController = this.Frame.GetController<ShowNavigationItemController>();
                if (armController != null)
                    armController.Active["ArmsEnabledByModelKey"] = true;
                if (showNavigationItemController != null)
                    showNavigationItemController.Active["Using ArmController"] = true;
            }
        }
        #region IModelExtender Members

        void IModelExtender.ExtendModelInterfaces(ModelInterfaceExtenders extenders)
        {
            extenders.Add<IModelArmDesign, IModelPanoptes>();
        }

        #endregion

    }
}
