﻿using System;
using System.Linq;
using DevExpress.ExpressApp;
using DevExpress.Data.Filtering;
using DevExpress.Persistent.Base;
using DevExpress.ExpressApp.Updating;
using DevExpress.Xpo;
using DevExpress.ExpressApp.Xpo;
using DevExpress.Persistent.BaseImpl;
using DevExpress.ExpressApp.Security.Strategy;
using Xafari.Security.Xpo;
using DevExpress.ExpressApp.Security;

namespace Panoptes.Module.DatabaseUpdate {
    // For more typical usage scenarios, be sure to check out https://documentation.devexpress.com/eXpressAppFramework/clsDevExpressExpressAppUpdatingModuleUpdatertopic.aspx
    public class Updater : ModuleUpdater {
        public Updater(IObjectSpace objectSpace, Version currentDBVersion) :
            base(objectSpace, currentDBVersion) {
        }
        public override void UpdateDatabaseAfterUpdateSchema() {
            base.UpdateDatabaseAfterUpdateSchema();
            /*
            SecuritySystemUser sampleUser = ObjectSpace.FindObject<SecuritySystemUser>(new BinaryOperator("UserName", "User"));
            if (sampleUser == null)
            {
                sampleUser = ObjectSpace.CreateObject<SecuritySystemUser>();
                sampleUser.UserName = "User";
                sampleUser.SetPassword("");
            }
            XafariSecuritySystemRole defaultRole = CreateDefaultRole();
            sampleUser.Roles.Add(defaultRole);
            */
            /*
            SecuritySystemUser userAdmin = ObjectSpace.FindObject<SecuritySystemUser>(new BinaryOperator("UserName", "Admin"));
            if (userAdmin == null)
            {
                userAdmin = ObjectSpace.CreateObject<SecuritySystemUser>();
                userAdmin.UserName = "Admin";
                // Set a password if the standard authentication type is used
                userAdmin.SetPassword("admin");
            }*/
            // If a role with the Administrators name doesn't exist in the database, create this role
            XafariSecuritySystemRole adminRole = ObjectSpace.FindObject<XafariSecuritySystemRole>(new BinaryOperator("Name", "Administrator"));
            if (adminRole == null)
            {
                adminRole = ObjectSpace.CreateObject<XafariSecuritySystemRole>();
                adminRole.Name = "Administrator";
            }
            adminRole.IsAdministrative = true;
            //userAdmin.Roles.Add(adminRole);

            ObjectSpace.CommitChanges(); //Uncomment this line to persist created object(s).
        }

        private XafariSecuritySystemRole CreateDefaultRole()
        {
            XafariSecuritySystemRole defaultRole = ObjectSpace.FindObject<XafariSecuritySystemRole>(new BinaryOperator("Name", "Users"));
            if (defaultRole == null)
            {
                defaultRole = ObjectSpace.CreateObject<XafariSecuritySystemRole>();
                defaultRole.Name = "Users";

                defaultRole.AddObjectAccessPermission<XafariSecuritySystemRole>("[Oid] = CurrentUserId()", SecurityOperations.ReadOnlyAccess);
                defaultRole.AddMemberAccessPermission<SecuritySystemUser>("ChangePasswordOnFirstLogon", SecurityOperations.Write);
                defaultRole.AddMemberAccessPermission<SecuritySystemUser>("StoredPassword", SecurityOperations.Write);
                defaultRole.SetTypePermissionsRecursively<XafariSecuritySystemRole>(SecurityOperations.Read, SecuritySystemModifier.Allow);
                defaultRole.SetTypePermissionsRecursively<ModelDifference>(SecurityOperations.ReadWriteAccess, SecuritySystemModifier.Allow);
                defaultRole.SetTypePermissionsRecursively<ModelDifferenceAspect>(SecurityOperations.ReadWriteAccess, SecuritySystemModifier.Allow);
            }
            return defaultRole;
        }
        public override void UpdateDatabaseBeforeUpdateSchema() {
            base.UpdateDatabaseBeforeUpdateSchema();
        }
    }
}
